package com.kuna.rythmgame;

import java.io.BufferedReader;
import java.io.FileReader;
import java.util.ArrayList;

import android.util.Log;

public class BMS
{
	boolean inited = false;
	ArrayList<String> bms_info_name = new ArrayList<String>();
	ArrayList<String> bms_info_value = new ArrayList<String>();
	String[][] noteData;
	
	int bms_keynum = 0;
	boolean bms_DP = false;
	
	// timer
	int[][] note_time;	// MILLsec [key][ind]
	String[][] note_data;
	int[] note_index;
	
	public boolean init(boolean forceinit) {
		if (!forceinit && inited) return false;
		
		noteData = new String[30][10000];
		
		note_time = new int[30][10000];
		note_data = new String[30][10000];
		note_index = new int[30];

		return true;
	}
	
	public boolean init() {
		return init(false);
	}
	
	public void reset() {
		//noteData = "";
		bms_info_name.clear();
		bms_info_value.clear();
		bms_keynum = 0;
		bms_DP = false;
	}
	
	public void readFile(String path) {
		if (!inited) init();
		
		String buf;
		String _num, _key;
		
		try {
			BufferedReader br = new BufferedReader(new FileReader( path ));
			
			boolean mainData = false;
			while ((buf=br.readLine()) != null) {
				//Log.v("data", String.format("%s", buf));
				
				if (!mainData) {
					// TODO: BMSINFO
					if (buf.indexOf("#") >= 0) {
						int _i = buf.indexOf(" ");
						String a = buf.substring(0, _i) ;
						String  b = buf.substring(_i+1) ;
						bms_info_name.add( buf.substring(0, _i) );
						bms_info_value.add( buf.substring(_i+1) );
					}
					
					// TODO: NOTEDATA
					if (buf.indexOf("MAIN DATA FIELD") > 0) {
						mainData = true;
					}
					continue;
				}
				
				if (buf.length() < 7)	// empty line
					continue;
				
				_num = buf.substring(1,1+3);
				_key = buf.substring(4,4+2);
				if (_num.indexOf('-') >= 0 || _key.indexOf('-') >= 0) continue;

				int num = Integer.parseInt(_num);
				int key = Integer.parseInt(_key);
				/**/
				bms_keynum = (bms_keynum>(key%10)||key<10)?bms_keynum:(key%10);
				bms_DP = bms_DP || (key>20);
				
				if (key < 30) { /* exception check */
					//Log.v("readFile", String.format("%s, %s", _num, _key));
					noteData[key][num] = buf.substring(7);
					
					// proc on time & data
					int ni = note_index[key];
					
					int div = noteData[key][num].length();
					// BPM ó
					/* second per beat = (60.0f*4/noteBPM) */
					float spb = 60.0f*4 / getValueInt("#BPM");
					for (int i=0; i<div/2; i++)
					{
						String _s = noteData[key][num].substring(i*2, i*2+2);
						if (_s.equals("00")) continue;
						note_data[key][ni] = new String(_s);	// pointer careful!
						note_time[key][ni] = (int)((num*spb + spb/(div/2)*i) * 1000);
						ni++;
					}

					note_index[key] = ni;
				}
			}
		} catch (Throwable e) {
			Log.v("readFile-error", "err");
		}
		
		return;
	}
	
	public int getNextTime(int key, int milisec) {
		int n = 0;
		for (; n<note_index[key]; n++)
			if (note_time[key][n] > milisec) break;
		
		// end
		if (n==note_index[key]) return 9999999;
		
		return note_time[key][n];
	}
	
	public int getPrevTime(int key, int milisec) {
		int n = 0;
		for (n=note_index[key]-1; n>=0; n--)
			if (note_time[key][n] <= milisec) break;

		// start
		if (n<0) return -1;
		
		return note_time[key][n];
	}
	
	
	public String getValue(String s) {
		for (int i=0; i<bms_info_name.size(); i++)
		{
			if (bms_info_name.get(i).equals(s))
				return bms_info_value.get(i);
		}
		return "";
	}
	
	public int getValueInt(String s) {
		try {
			for (int i=0; i<bms_info_name.size(); i++)
			{
				if (bms_info_name.get(i).equals(s))
					return Integer.parseInt( bms_info_value.get(i) );
			}
		} catch (Exception e) {
			return -1;
		}
		
		return -1;
	}
}