package com.kuna.rythmgame;

import java.io.File;
import java.io.FilenameFilter;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Locale;

import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Paint;
import android.graphics.Rect;
import android.os.Handler;
import android.os.Message;
import android.util.Log;
import android.view.View;

public class Menu {
	public final static int GAMEMODE_PRE = 0;
	public final static int GAMEMODE_MENU = 1;
	public final static int GAMEMODE_LIST = 2;
	public final static int GAMEMODE_PLAY = 3;
	
	View _parent;
	Play _p_obj;
	int game_mode;
	
	String song_path;
	
	Menu(View v, Play p) {
		// init
		//game_mode=GAMEMODE_MENU; //for debugging
		
		_parent = v;
		_p_obj = p;
	}
	
	public void init() {
	}
	
	public void draw(Canvas c) {
		// draw
		switch(game_mode) {
		case GAMEMODE_PRE:
			draw_pre(c);
			break;
		case GAMEMODE_MENU:
			draw_menu(c);
			break;
		case GAMEMODE_LIST:
			draw_list(c);
			break;
		}
		
		if (loading)
			draw_loading(c);
	}
	
	Paint dp_p;
	public void draw_pre(Canvas c) {
		dp_p.setAlpha(pp_alpha);
		c.drawBitmap(pp_bit, null, pp_r, dp_p);
	}
	
	public void draw_menu(Canvas c) {
		if (!pm_init) return;
		c.drawBitmap(pm_bg, null, new Rect(0,0,800,480), null);
		c.drawBitmap(pm_logo, 400, 60, null);
		c.drawBitmap((Bitmap) pm_menu.get(0), 560, 240, null);
		c.drawBitmap((Bitmap) pm_menu.get(1), 560, 320, null);
		c.drawBitmap((Bitmap) pm_menu.get(2), 560, 400, null);
	}
	
	Paint dl_p;
	public void draw_list(Canvas c) {
		if (!pl_init) return;
		
		// draw bg
		c.drawBitmap(pl_bg, null, new Rect(0,0,800,480), null);
		
		// draw song info
		
		
		// draw song list
		int p = 200 + pl_list_top;
		for (int i=0; i<pl_filepath.size(); i++)
		{
			c.save();
			c.translate(800-250-p/2, p);
			
			c.drawBitmap(pl_bar, 0, 0, null);
			dl_p = new Paint();
			dl_p.setColor(0xFFFFFFFF);
			dl_p.setTextSize(25);
			c.drawText(pl_title.get(i), 16, 42, dl_p);
			
			p += 100;
			c.restore();
		}
	}
	
	int percent;
	boolean loading=false;
	public void draw_loading(Canvas c) {
		Paint p = new Paint();
		p.setColor(0xFF000000);
		c.drawRect(new Rect(0,0,800,480), p);
		
		p.setColor(0xFFFFFFFF);
		c.drawRect(new Rect(0,475,800*percent/100,480), p);
	}

	/* timer proc */
	Calendar gameDate;
	long startTime, nowTime;
	public void setStartTime() {
		startTime = Calendar.getInstance(Locale.KOREAN).getTimeInMillis();
	}
	public long getEclipsedTime(boolean refresh) {
		if (refresh) nowTime = Calendar.getInstance(Locale.KOREAN).getTimeInMillis();
		return nowTime - startTime;
	}
	public int getEclipsedTime() {
		return  (int) getEclipsedTime(false);
	}
	
	int pp_alpha;
	Bitmap pp_bit;
	Rect pp_r;
	boolean pp_init=false;
	
	Bitmap pp_l1, pp_l2;
	public void proc_pre() {
		// setStartTime() should be already called
		if (!pp_init) {
			dp_p = new Paint();
			
			pp_l1 = BitmapFactory.decodeResource(_parent.getResources(), R.drawable.copy1);
			pp_l2 = BitmapFactory.decodeResource(_parent.getResources(), R.drawable.copy2);
			
			setStartTime();
			pp_init = true;	//..mistake
		}
		
		getEclipsedTime(true);
		if (getEclipsedTime()/3000 >= 2)
		{
			game_mode = GAMEMODE_MENU;
			return;
		}
		
		// 2 sec per clip
		int t = getEclipsedTime() % 3000;
		switch ((getEclipsedTime() / 3000)) {
		case 0:
			pp_bit = pp_l1;
			break;
		case 1:
			pp_bit = pp_l2;
			break;
		}
		if ( t<500 ) pp_alpha = t*255/500;
		else if ( t>2500 ) pp_alpha = (3000-t)*255/500;
		else pp_alpha = 255;
		
		pp_r = new Rect(0,0,800,480);
	}
	
	Bitmap pm_bg;
	Bitmap pm_logo;
	ArrayList<Bitmap> pm_menu = new ArrayList<Bitmap>();
	ArrayList<Bitmap> pm_menu_hover = new ArrayList<Bitmap>();
	boolean pm_init = false;
	boolean pm_loading = false;
	public void proc_menu() {
		if (!pm_init) {
			if (!pm_loading) {
				new Thread(new Runnable()
				{
					public void run()
					{
						pm_loading = true;
						loading = true;
						percent=0;
						
						pm_bg = BitmapFactory.decodeFile("/sdcard/.kuna/RythmNamu/Skins/Menu/bg.png");
						pm_logo = BitmapFactory.decodeFile("/sdcard/.kuna/RythmNamu/Skins/Menu/logo.png");
						pm_menu.add(BitmapFactory.decodeFile("/sdcard/.kuna/RythmNamu/Skins/Menu/menu1.png"));
						pm_menu.add(BitmapFactory.decodeFile("/sdcard/.kuna/RythmNamu/Skins/Menu/menu2.png"));
						pm_menu.add(BitmapFactory.decodeFile("/sdcard/.kuna/RythmNamu/Skins/Menu/menu3.png"));

						loading = false;
						percent=100;
						
						// Initalize after loading
						pm_init = true;
					}
				}
				).start(); 
				
			} 
			return;
		}
		
		// do proc, like mouse event
	}

	Bitmap pl_bg;
	Bitmap pl_bar;
	boolean pl_init = false;
	boolean pl_loading = false;
	ArrayList<String> pl_filepath = new ArrayList<String>();
	ArrayList<String> pl_title = new ArrayList<String>();
	ArrayList<String> pl_artist = new ArrayList<String>();
	ArrayList<Integer> pl_level = new ArrayList<Integer>();
	
	int pl_list_top;
	public void proc_list() {
		if (!pl_init) {
			if (!pl_loading) {
				new Thread(new Runnable()
				{
					public void run()
					{
						pl_loading = true;
						loading = true;
						percent=0;

						pl_bg = BitmapFactory.decodeFile("/sdcard/.kuna/RythmNamu/Skins/Select/bg.png");
						pl_bar = BitmapFactory.decodeFile("/sdcard/.kuna/RythmNamu/Skins/Select/bar.png");
						
						File sdDir = new File("/sdcard/.kuna/RythmNamu/Songs");
						File[] subDirs = sdDir.listFiles();
						
						// BMS
						BMS _b = new BMS();
						_b.init();
						
						if(subDirs != null){
							int cnt = subDirs.length;
							int nc = 0;
							
							for(File item: subDirs){
								if(item.isDirectory()){
									File[] subDirs2 = item.listFiles(new FilenameFilter() {
										public boolean accept(File dir, String filename) {
											if (filename.endsWith(".bms")) return true;
											if (filename.endsWith(".bme")) return true;
											return false;
										}
									});
									for (File str: subDirs2) {
										// load BMS
										_b.readFile(str.getPath());
										Log.v("readbms", String.format("Key:%d, DP:%d", _b.bms_keynum, _b.bms_DP?1:0));
										
										// key>=8, nodp
										if (_b.bms_keynum >= 8 && !_b.bms_DP) {
											pl_filepath.add(str.getPath());
											pl_title.add( _b.getValue("#TITLE") );
											pl_artist.add( _b.getValue("#ARTIST") );
											pl_level.add( _b.getValueInt("#PLAYLEVEL") );
										}
										
										_b.reset();
									}
								}
								
								nc++;
								percent = 100*nc/cnt;
							}
						}
						
						loading = false;
						percent=100;
						
						// Initalize after loading
						pl_init = true;
					}
				}
				).start(); 
				
			} 
			return;
		}
		
		// mousemove
		if (moving) {
			pl_list_top += getDifferenceY();
			resetPos();
		}
	}

	
	/* mouse move Event */
	int ox; int oy;
	int nx; int ny;
	boolean pressing = false;
	boolean moving = false;
	public void mouseDown(int x, int y) {
		ox = x;
		oy = y;
		pressing = true;
	}
	
	public void mouseMove(int x, int y) {
		nx = x;
		ny = y;
		moving = true;
	}
	
	public void mouseUp(int x, int y) {
		moving = pressing = false;

		// chk event
		if (game_mode == GAMEMODE_LIST) {
			if (!pl_init) return;
			int p = 200 + pl_list_top;
			for (int i=0; i<pl_filepath.size(); i++)
			{
				int _x=800-250-p/2;
				
				if (x>_x && y>p && y<p+60) {
					// go with select song
					Log.v("sel filepath", pl_filepath.get(i));
					_p_obj.init(pl_filepath.get(i));
					
					song_path = pl_filepath.get(i);
					game_mode = GAMEMODE_PLAY;
				}
				
				p += 100;
			}
		}
	}

	public int getDifferenceX() {
		return nx-ox;
	}
	public int getDifferenceY() {
		return ny-oy;
	}
	public void resetPos() {
		ox = nx;
		oy = ny;
	}
}