package com.kuna.rythmgame;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.Locale;

import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Paint;
import android.graphics.Rect;
import android.media.AudioManager;
import android.media.SoundPool;
import android.util.Log;
import android.view.MotionEvent;
import android.view.View;

// 1. judge
// 2. note proc
// 3. draw
// 4. sound

public class Play {
	
	// judgement
	int JUDGE_GREAT = 3;
	int JUDGE_GOOD = 2;
	int JUDGE_POOR = 1;

	boolean[] note_pressed;
	boolean[] note_cache;
	
	int[] note_judge;
	int[] note_judge_index;
	
	int scr_margin = 10;
	int note_margin=10;
	
	ArrayList<Bitmap> bms_bg = new ArrayList<Bitmap>();
	ArrayList<String> bms_bg_str = new ArrayList<String>();
	ArrayList<Integer> bms_sound = new ArrayList<Integer>();
	ArrayList<String> bms_sound_str = new ArrayList<String>();
	SoundPool sp = new SoundPool( 255, AudioManager.STREAM_MUSIC, 0 );
	
	View _parent;
	BMS _bms;
	
	Play(View v, BMS b) {
		_parent = v;
		_bms = new BMS();
		_bms.init();
		
		note_judge = new int[30];
		note_judge_index = new int[30];

		note_pressed = new boolean[10];	// 
		note_cache =  new boolean[10];	// (boolean[])note_pressed.clone();
	}
	
	public void init(final String path) {	/* bmspath */
		// same to reset
		reset();
		
		// thread start
		new Thread(new Runnable()
		{
			public void run()
			{
				loading = true;
				loading_perc = 0;
				
				// load progress
				_bms.reset();
				_bms.readFile(path);
				
				int _l = 0;
				while (true) {
					int _ = path.indexOf("/", _l+1);
					if (_<0) break;
					_l = _;
				}
				String folderpath = path.substring(0, _l+1);
				Log.v("load", folderpath);
				
				// sound & image load
				int _cnt = _bms.bms_info_name.size();
				for (int i=0; i<_cnt; i++)
				{
					String _s = _bms.bms_info_name.get(i);
					String _s_cmd, _s_path;
					if (_s.indexOf("#BMP") >= 0) {
						_s_cmd = _s.substring(4);
						_s_path = folderpath + _bms.bms_info_value.get(i);
						bms_bg_str.add(_s_cmd);
						bms_bg.add( BitmapFactory.decodeFile( _s_path ) );
						//Log.v("load-bitmap", _s_path);
					}
					if (_s.indexOf("#WAV") >= 0) {
						_s_cmd = _s.substring(4);
						_s_path = folderpath + _bms.bms_info_value.get(i);
						bms_sound_str.add(_s_cmd);
						bms_sound.add( sp.load(_s_path, 1) );
					}
					
					loading_perc = i*100/_cnt;
				}
				
				// loading fin!
				setStartTime();
				loading = false;
			}
		}).start();
	}
	
	boolean loading = true;
	int loading_perc = 0;
	public void reset()
	{
		loading = true;
		loading_perc = 0;
	}
	
	public void draw(Canvas c) {
		if (loading) {
			// when loading - draw
			Paint p = new Paint();
			p.setColor(0xFF000000);
			c.drawRect(new Rect(0, 0, 800, 480), p);
			p.setColor(0xFFFFFFFF);
			c.drawRect(new Rect(0, 475, 800*loading_perc / 100, 480), p);
			return;
		}
		
		// for - 800x480 (wide)
		Paint p = new Paint();
		p.setColor(0xFF000000);
		c.drawRect(new Rect(0, 0, 800, 480), p);
		
		if (nowBMP != null) {
			Paint bp = new Paint();
			bp.setAlpha(100);
			c.drawBitmap(nowBMP, null, new Rect(0, 0, 800, 480), bp);	
		}
		
		p.setColor(0x33FFFFFF);
		c.drawRect(new Rect(10, 10, 790, 470), p);
		

		int t = 0, nowBeat = 0;
		t = getEclipsedTime();
		
		for (int j=1; j<=2; j++)
			for (int i=1;i<=4; i++)
			{
				p.reset();
				
				p.setColor(0x66000000);
				int nt = _bms.getNextTime((j-1)*4+i +10, t);
				int pt = _bms.getPrevTime((j-1)*4+i +10, t);
				if (nt - t < 300) {
					p.setColor(0x66FFFF00);
					
					int a = (int)((float)(nt-t) * (150.0f / 300));
					if (a>150) a=150;
					p.setAlpha(150-a);
				} else if (t - pt < 200) {
					p.setColor(0x66FF00FF);

					int a = (int)((float)(t-pt) * (150.0f / 200));
					if (a>150) a=150;
					p.setAlpha(150-a);
				}
				
				
				c.drawRect(new Rect(
						scr_margin+note_margin + (800-scr_margin*2-note_margin*(4+1))/4*(i-1) + note_margin*(i-1),
						scr_margin+note_margin + (480-scr_margin*2-note_margin*(2+1))/2*(j-1) + note_margin*(j-1),
						scr_margin+note_margin + (800-scr_margin*2-note_margin*(4+1))/4*(i) + note_margin*(i-1),
						scr_margin+note_margin + (480-scr_margin*2-note_margin*(2+1))/2*(j) + note_margin*(j-1)), p);
				
				if (note_pressed[(j-1)*4+i])
				{
					p.reset();
					p.setStyle(Paint.Style.STROKE);
					p.setColor(0xCCFFFF00);
					p.setStrokeWidth(10);
					c.drawRect(new Rect(
							scr_margin+note_margin + (800-scr_margin*2-note_margin*(4+1))/4*(i-1) + note_margin*(i-1) + 5,
							scr_margin+note_margin + (480-scr_margin*2-note_margin*(2+1))/2*(j-1) + note_margin*(j-1) + 5,
							scr_margin+note_margin + (800-scr_margin*2-note_margin*(4+1))/4*(i) + note_margin*(i-1) - 5,
							scr_margin+note_margin + (480-scr_margin*2-note_margin*(2+1))/2*(j) + note_margin*(j-1) - 5), p);
				}
				
				p.reset();
				p.setTextSize(20);
				String s="";
				switch(note_judge[(j-1)*4+i +10]) {
				case 3:	// great
					s = "GREAT";
					p.setColor(0xCC9999FF);
					break;
				case 2:
					s = "BAD";
					p.setColor(0xCCFFFF99);
					break;
				case 1:
					s = "POOR";
					p.setColor(0xCCFF9999);
					break;
				}
				
				c.drawText(s, i*200-100, j*240-120, p);
			}
		

		p.setColor(0xFF000000);
		
		Paint fp = new Paint();
		fp.setColor(0xFFFFFFFF);
		fp.setTextSize(18);
		c.drawText(String.format("time:%d", t), 30, 50, fp);
		c.drawText(String.format("beat:%d", nowBeat), 30, 60, fp);
	}

	// touch
	public void touchEvent(MotionEvent event) {
		if (!loading) {
			for (int i=1; i<=2; i++)
				for (int j=1; j<=4; j++)
					note_pressed[(i-1)*4+j] = false;
			
			for (int _i=0; _i<event.getPointerCount(); _i++) {
				// check touch status
				float px = event.getX(_i);
				float py = event.getY(_i);

				//Log.v("move", String.format("%d-%d,%d // %d", _i, (int)px, (int)py, event.getAction()));
				if ((event.getAction() & MotionEvent.ACTION_MASK) == MotionEvent.ACTION_MOVE ||
						(event.getAction() & MotionEvent.ACTION_MASK) == MotionEvent.ACTION_DOWN ||
						(event.getAction() & MotionEvent.ACTION_MASK) == MotionEvent.ACTION_POINTER_DOWN) {
					
					for (int j=1; j<=2; j++)
						for (int i=1; i<=4; i++)
						{
							if ((scr_margin+note_margin + (800-scr_margin*2-note_margin*(4+1))/4*(i-1) + note_margin*(i-1)) <= px &&
								scr_margin+note_margin + (480-scr_margin*2-note_margin*(2+1))/2*(j-1) + note_margin*(j-1) <= py && 
								scr_margin+note_margin + (800-scr_margin*2-note_margin*(4+1))/4*(i) + note_margin*(i-1) >= px &&
								scr_margin+note_margin + (480-scr_margin*2-note_margin*(2+1))/2*(j) + note_margin*(j-1) >= py)
								note_pressed[(j-1)*4+i] = true;
						}
				}
			}
		}
		
	}
	
	// should be called every frame
	public void proc() {
		if (!loading) {
			getEclipsedTime(true);
			int t = getEclipsedTime();
			
			// 1. judge / touch
			// check press event
			for (int i=1; i<=2; i++)
				for (int j=1; j<=4; j++) if ((note_cache[4*(i-1)+j] == false) && (note_pressed[4*(i-1)+j] == true)) {
					proc_press( (i-1)*4+j +10, t);
					//Log.v("press", String.format("%d,%d", i, j));
				}
			// chk  judge
			proc_time(t);
			note_cache = (boolean[])note_pressed.clone();
			
			
			// 2. screen / sprite
		}
		
		
		// screen refresh
		_parent.invalidate();
	}
	
	// judge	
	public void proc_press(int key, int militime) {
		int n=note_judge_index[key];
		
		// sound play
		Log.v("press", String.format("key:%d, index:%d", key, n));
		
		for (int i=0; i<100; i++)
			Log.v("debug", String.format("%d",_bms.note_time[key][i]));
		runWAV( _bms.note_data[key][n] );
		
		// dont type next note
		if (_bms.note_time[key][n] - militime > 300) return;
		
		//Log.v("debug", String.format("%d", _bms.note_time[key][n]));
		int d=Math.abs(_bms.note_time[key][n] - militime);
		if (d<100) {
			note_judge[key] = JUDGE_GREAT;
			note_judge_index[key]++;
		} else if (d<300) {
			note_judge[key] = JUDGE_GOOD;
			note_judge_index[key]++;
		}
	}
	
	public void proc_time(int militime) {
		// if not press during time ...
		for (int i=11; i<=18; i++) {
			int n=note_judge_index[i];
			for (;
					militime-300>_bms.note_time[i][n] && n<_bms.note_index[i];
					n++) {
				note_judge[i] = JUDGE_POOR;
			}
			note_judge_index[i] = n;
		}
		
		
		// play BGM BMS
		int n=note_judge_index[1];
		if (militime > _bms.note_time[1][n] && n<_bms.note_index[1]) {
			runWAV (_bms.note_data[1][n]);
			n++;
		}
		note_judge_index[1] = n;
		
		// set BGA
		n=note_judge_index[4];
		if (militime > _bms.note_time[4][n] && n<_bms.note_index[4]) {
			runBMP (_bms.note_data[4][n]);
			n++;
		}
		note_judge_index[4] = n;
		n=note_judge_index[6];
		if (militime > _bms.note_time[6][n] && n<_bms.note_index[6]) {
			runBMP (_bms.note_data[6][n]);
			n++;
		}
		note_judge_index[6] = n;
	}
	
	
	// bitmap/sound
	Bitmap nowBMP;
	public void runBMP(String code) {
		for (int i=0; i<bms_bg_str.size(); i++) {
			if (bms_bg_str.get(i).equals(code)) 
				nowBMP = bms_bg.get(i);
		}
	}
	
	public void runWAV(String code) {
		for (int i=0; i<bms_sound_str.size(); i++)
			if (bms_sound_str.get(i).equals(code)) {
				sp.play(bms_sound.get(i), 1f, 1f, 0, 0, 1f);
				Log.v("sound", "code");
			}
	}
	

	/* timer proc */
	Calendar gameDate;
	long startTime, nowTime;
	public void setStartTime() {
		startTime = Calendar.getInstance(Locale.KOREAN).getTimeInMillis();
	}
	public long getEclipsedTime(boolean refresh) {
		if (refresh) nowTime = Calendar.getInstance(Locale.KOREAN).getTimeInMillis();
		return nowTime - startTime;
	}
	public int getEclipsedTime() {
		return  (int) getEclipsedTime(false);
	}
}