package com.kuna.rythmgame;

import java.io.*;
import java.util.Calendar;
import java.util.Locale;

import android.content.Context;
import android.graphics.*;
import android.os.Handler;
import android.os.Message;
import android.util.Log;
import android.view.KeyEvent;
import android.view.MotionEvent;
import android.view.View;

public class RythmView extends View {
	
	Calendar gameDate; //  ð ´
	
	int scr_margin;
	int note_margin;

	
	boolean draw_ready = false;
	
	long startTime;
	
	BMS m_bms;
	Menu c_menu;
	Play c_play;

	public RythmView(Context context) {
		super(context);
		
		// data load?
		init();
	}

	public void init()
	{
		scr_margin = 20;
		note_margin = 10;

		readFile();
		
		draw_ready = true;
		
		gameDate = Calendar.getInstance(Locale.KOREAN);
		startTime = gameDate.getTimeInMillis();

		timerInit();
		startTimer(20);

		c_play = new Play(this, m_bms);
		c_menu = new Menu(this, c_play);
		c_menu.init();
		
	}
	
	public void readFile() {
		m_bms = new BMS();
		m_bms.init();
	}
	
	@Override
	public void onDraw(Canvas canvas) {
		if (c_menu.game_mode == Menu.GAMEMODE_PLAY)
			c_play.draw(canvas);
		else
			c_menu.draw(canvas);
		
		super.onDraw(canvas);
	}
	
	public void draw_menu(Canvas c) {
		Paint p = new Paint();
		p.setColor(0xFFFFFFFF);
		c.drawRect(new Rect(0, 0, 800, 480), p);
	}

	public boolean onTouchEvent(MotionEvent event) {
		if (c_menu.game_mode == Menu.GAMEMODE_MENU)
			c_menu.game_mode = Menu.GAMEMODE_LIST;
		if (c_menu.game_mode == Menu.GAMEMODE_PLAY)
			c_play.touchEvent(event);
		
		switch(event.getAction()) {
		case MotionEvent.ACTION_DOWN:
			c_menu.mouseDown((int)event.getX(), (int)event.getY());
			break;
		case MotionEvent.ACTION_MOVE:
			c_menu.mouseMove((int)event.getX(), (int)event.getY());
			break;
		case MotionEvent.ACTION_UP:
			c_menu.mouseUp((int)event.getX(), (int)event.getY());
			break;
		}
		
		return true;// super.onTouchEvent(event);
	}

	/* timer proc */
	Handler h;
	boolean _timer = false;
	int _timer_tick = 20;
	public void timerInit() {	
		h = new Handler() {
			public void handleMessage(Message msg) {
				switch(c_menu.game_mode) {
				case Menu.GAMEMODE_PRE:
					c_menu.proc_pre();
					break;
				case Menu.GAMEMODE_MENU:
					c_menu.proc_menu();
					break;
				case Menu.GAMEMODE_LIST:
					c_menu.proc_list();
					break;
				case Menu.GAMEMODE_PLAY:
					c_play.proc();
					break;
				}	
				
				invalidate();
				if (_timer) h.sendEmptyMessageDelayed(0, _timer_tick);
			}
		};
	}

	public void startTimer() {
		if (_timer) return;
		_timer = true;
		h.sendEmptyMessage(0);
	}
	public void startTimer(int tick) {
		if (_timer) return;
		_timer = true;
		_timer_tick = tick;
		h.sendEmptyMessage(0);
	}
	
	public void stopTimer() {
		_timer = false;
	}
}